<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_Discount1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_Discount1 extends AbstractStructArrayBase
{
    /**
     * The ChildA
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_Discount[]
     */
    public $ChildA;
    /**
     * Constructor method for ArrayOfJPSOAP_Discount1
     * @uses ArrayOfJPSOAP_Discount1::setChildA()
     * @param \StructType\JPSOAP_Discount[] $childA
     */
    public function __construct(array $childA = array())
    {
        $this
            ->setChildA($childA);
    }
    /**
     * Get ChildA value
     * @return \StructType\JPSOAP_Discount[]|null
     */
    public function getChildA()
    {
        return $this->ChildA;
    }
    /**
     * This method is responsible for validating the values passed to the setChildA method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChildA method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChildAForArrayConstraintsFromSetChildA(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_Discount1ChildAItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_Discount1ChildAItem instanceof \StructType\JPSOAP_Discount) {
                $invalidValues[] = is_object($arrayOfJPSOAP_Discount1ChildAItem) ? get_class($arrayOfJPSOAP_Discount1ChildAItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_Discount1ChildAItem), var_export($arrayOfJPSOAP_Discount1ChildAItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChildA property can only contain items of type \StructType\JPSOAP_Discount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChildA value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount[] $childA
     * @return \ArrayType\ArrayOfJPSOAP_Discount1
     */
    public function setChildA(array $childA = array())
    {
        // validation for constraint: array
        if ('' !== ($childAArrayErrorMessage = self::validateChildAForArrayConstraintsFromSetChildA($childA))) {
            throw new \InvalidArgumentException($childAArrayErrorMessage, __LINE__);
        }
        $this->ChildA = $childA;
        return $this;
    }
    /**
     * Add item to ChildA value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount $item
     * @return \ArrayType\ArrayOfJPSOAP_Discount1
     */
    public function addToChildA(\StructType\JPSOAP_Discount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_Discount) {
            throw new \InvalidArgumentException(sprintf('The ChildA property can only contain items of type \StructType\JPSOAP_Discount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChildA[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_Discount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_Discount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildA
     */
    public function getAttributeName()
    {
        return 'ChildA';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_Discount1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
